// Generated by CoffeeScript 1.4.0
(function() {
  var Switchboard, assert;

  assert = require('assert');

  Switchboard = require('../').Switchboard;

  describe('switchboard', function() {
    this.timeout(1000);
    return describe('multi-event handlers', function() {
      it('should not trigger handlers unless all events have occurred', function(done) {
        var the_switchboard;
        the_switchboard = new Switchboard();
        the_switchboard.on(['event1', 'event2'], function(data) {
          throw new Error('should not have triggered');
        });
        the_switchboard.emit('event1');
        return setTimeout((function() {
          return done();
        }), 10);
      });
      it('should trigger handlers after all events have been emitted', function(done) {
        var the_switchboard;
        the_switchboard = new Switchboard();
        the_switchboard.on(['event1', 'event2'], function(data) {
          return done();
        });
        the_switchboard.emit('event1');
        return the_switchboard.emit('event2');
      });
      it('should continue to trigger handlers on every matching event after all events have been emitted', function(done) {
        var the_switchboard, triggeredAgainOnce, triggeredAgainTwice;
        the_switchboard = new Switchboard();
        the_switchboard.on(['event1', 'event2'], function(data) {
          if (triggeredAgainOnce && triggeredAgainTwice) {
            return done();
          }
        });
        the_switchboard.emit('event1');
        the_switchboard.emit('event2');
        triggeredAgainOnce = true;
        the_switchboard.emit('event2');
        triggeredAgainTwice = true;
        return the_switchboard.emit('event1');
      });
      return it('should not trigger handlers after a call to .vanGogh()', function(done) {
        var the_switchboard;
        the_switchboard = new Switchboard();
        the_switchboard.on(['event1', 'event2'], function(data) {
          throw new Error('should not have triggered');
        });
        the_switchboard.emit('event1');
        the_switchboard.vanGogh();
        the_switchboard.emit('event2');
        return setTimeout((function() {
          return done();
        }), 10);
      });
    });
  });

}).call(this);
